import React, { Component, ReactNode } from "react";
export interface SelectionContextValue {
    selected?: any[];
    onRowSelect?: (rowKey: any, checked: boolean, rowIndex: number, e: any) => void;
    onAllRowsSelect?: (e: any, isUnSelect: boolean) => void;
    allRowsSelected?: boolean;
    allRowsNotSelected?: boolean;
    checkedStatus?: string;
    mode?: string;
    hideSelectColumn?: boolean;
    clickToSelect?: boolean;
    clickToSelectAndEditCell?: boolean;
    onSelect?: (row: any, checked: boolean, rowIndex: number, e: any) => boolean | undefined;
    onSelectAll?: (checked: boolean, selectedRows: any[], e: any) => void | any[];
    nonSelectable?: any[];
    hideSelectAll?: boolean;
}
interface SelectionProviderProps {
    children: ReactNode;
    data: any[];
    keyField: string;
    selectRow: {
        selected?: any[];
        mode?: string;
        hideSelectColumn?: boolean;
        clickToSelect?: boolean;
        clickToSelectAndEditCell?: boolean;
        onSelect?: (row: any, checked: boolean, rowIndex: number, e: any) => boolean;
        onSelectAll?: (checked: boolean, selectedRows: any[], e: any) => void | any[];
        nonSelectable?: any[];
    };
}
declare class SelectionProvider extends Component<SelectionProviderProps> {
    selected: any[];
    constructor(props: SelectionProviderProps);
    getSelected(): any[];
    componentDidUpdate(nextProps: SelectionProviderProps): void;
    handleRowSelect: (rowKey: any, checked: boolean, rowIndex: number, e: any) => void;
    handleAllRowsSelect: (e: any, isUnSelect: boolean) => void;
    render(): React.JSX.Element;
}
declare const _default: () => {
    Provider: typeof SelectionProvider;
    Consumer: React.Consumer<SelectionContextValue>;
};
export default _default;
