import React from "react";
import { Property } from "csstype";
interface HeaderCellProps {
    column: {
        dataField: string;
        text: string;
        type?: string;
        isDummyField?: boolean;
        hidden?: boolean;
        headerFormatter?: (column: any, index: number, extraData: any) => React.ReactNode;
        formatter?: (cell: any, row: any, rowIndex: number, formatExtraData: any) => React.ReactNode;
        formatExtraData?: any;
        headerClasses?: string | ((column: any, index: number) => string);
        classes?: string | ((cell: any, row: any, rowIndex: number) => string);
        headerStyle?: React.CSSProperties | ((column: any, index: number) => React.CSSProperties);
        headerSortingClasses?: string | ((column: any, sortOrder: string, isLastSorting: boolean, index: number) => string);
        headerSortingStyle?: React.CSSProperties | ((column: any, sortOrder: string, isLastSorting: boolean, index: number) => React.CSSProperties);
        style?: React.CSSProperties | ((cell: any, row: any, rowIndex: number) => React.CSSProperties);
        headerTitle?: boolean | ((column: any, index: number) => boolean | string);
        title?: boolean | ((cell: any, row: any, rowIndex: number) => boolean | string);
        headerEvents?: Record<string, (e: React.MouseEvent) => void>;
        events?: Record<string, (cell: any, row: any, rowIndex: number, e: React.MouseEvent) => void>;
        headerAlign?: Property.TextAlign | ((column: any, index: number) => Property.TextAlign);
        align?: string | ((cell: any, row: any, rowIndex: number) => string);
        headerAttrs?: React.HTMLAttributes<HTMLTableHeaderCellElement> | ((column: any, index: number) => React.HTMLAttributes<HTMLTableHeaderCellElement>);
        attrs?: React.HTMLAttributes<HTMLTableCellElement> | ((cell: any, row: any, rowIndex: number) => React.HTMLAttributes<HTMLTableCellElement>);
        sort?: boolean;
        sortFunc?: (a: any, b: any, order: string, column: any) => number;
        onSort?: (column: any, sortOrder: string) => void;
        sortCaret?: any;
        editor?: object;
        editable?: boolean | ((cell: any, row: any, rowIndex: number) => boolean);
        editCellStyle?: React.CSSProperties | ((cell: any, row: any, rowIndex: number) => React.CSSProperties);
        editCellClasses?: string | ((cell: any, row: any, rowIndex: number) => string);
        editorStyle?: React.CSSProperties | ((cell: any, row: any, rowIndex: number) => React.CSSProperties);
        editorClasses?: string | ((cell: any, row: any, rowIndex: number) => string);
        editorRenderer?: (editorProps: any, value: any, row: any, column: any, rowIndex: number, columnIndex: number) => React.ReactNode;
        validator?: (newValue: any, row: any, column: any) => boolean | string;
        filter?: any;
        filterRenderer?: (onCustomFilter: (value: any) => void, column: any) => React.ReactNode;
        filterValue?: (cell: any, row: any) => string;
        searchable?: boolean;
    };
    index: number;
    onSort?: (column: any) => void;
    sorting?: boolean;
    sortOrder?: string;
    sortCaret?: any;
    isLastSorting?: boolean;
    onFilter?: (filterData: Record<string, any>) => void;
    filterPosition?: string;
    currFilters?: Record<string, any>;
    onExternalFilter?: (column: any, filterType: string) => (value: any) => void;
    globalSortCaret?: (order: string, column: any) => React.ReactNode;
}
declare const HeaderCell_base: {
    new (...props: any[]): {
        [x: string]: any;
        createDefaultEventHandler(cb: (e: any, column: any, columnIndex: number) => void): (e: any) => void;
        delegate(attrs?: Record<string, any>): Record<string, any>;
    };
} & typeof React.Component;
declare class HeaderCell extends HeaderCell_base<HeaderCellProps> {
    render(): React.DetailedReactHTMLElement<React.HTMLAttributes<HTMLTableHeaderCellElement>, HTMLElement>;
}
export default HeaderCell;
