"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSelectedRows = exports.unSelectableKeys = exports.selectableKeys = exports.getSelectionSummary = void 0;
var utils_1 = __importDefault(require("../utils"));
var rows_1 = require("./rows");
var getSelectionSummary = function getSelectionSummary() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var keyField = arguments.length > 1 ? arguments[1] : undefined;
  var selected = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var allRowsSelected = data.length > 0;
  var allRowsNotSelected = true;
  var rowKeys = data.map(function (d) {
    return utils_1["default"].get(d, keyField);
  });
  var _loop = function _loop() {
    var curr = rowKeys[i];
    if (typeof selected.find(function (x) {
      return x === curr;
    }) === "undefined") {
      allRowsSelected = false;
    } else {
      allRowsNotSelected = false;
    }
  };
  for (var i = 0; i < rowKeys.length; i += 1) {
    _loop();
  }
  return {
    allRowsSelected: allRowsSelected,
    allRowsNotSelected: allRowsNotSelected
  };
};
exports.getSelectionSummary = getSelectionSummary;
var selectableKeys = function selectableKeys() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var keyField = arguments.length > 1 ? arguments[1] : undefined;
  var skips = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  if (skips.length === 0) {
    return data.map(function (row) {
      return utils_1["default"].get(row, keyField);
    });
  }
  return data.filter(function (row) {
    return !utils_1["default"].contains(skips, utils_1["default"].get(row, keyField));
  }).map(function (row) {
    return utils_1["default"].get(row, keyField);
  });
};
exports.selectableKeys = selectableKeys;
var unSelectableKeys = function unSelectableKeys(selected) {
  var skips = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  if ((skips === null || skips === void 0 ? void 0 : skips.length) === 0) {
    return [];
  }
  return selected.filter(function (x) {
    return utils_1["default"].contains(skips, x);
  });
};
exports.unSelectableKeys = unSelectableKeys;
var getSelectedRows = function getSelectedRows() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var keyField = arguments.length > 1 ? arguments[1] : undefined;
  var selected = arguments.length > 2 ? arguments[2] : undefined;
  return selected.map(function (k) {
    return (0, rows_1.getRowByRowId)(data, keyField, k);
  }).filter(function (x) {
    return !!x;
  });
};
exports.getSelectedRows = getSelectedRows;